/* erwin -- html editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *                Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


#include "erwin.h"

GtkStyle *style = NULL;
GdkFont *font = NULL;

char file[1024] = FILENAME;
gchar *FileName = "nothing";
GtkWidget *main_window;

void
save_file ()
{
  FILE *fd;
  gchar *erwin;
  struct document *document;
  IS_TEXT_NULL
    document = (g_list_nth (documents, gtk_notebook_get_current_page (GTK_NOTEBOOK (notebook_main))))->data;

  if (strcmp (file, FILENAME))
    {
#ifdef DEBUG
      g_print ("\nNow saving file %s\n", file);
#endif
      if (gtk_text_get_length (GTK_TEXT (text)))
	{
	  if (!is_file_readonly (file))
	    {
#ifdef DEBUG
	      g_print ("\nNow writing to file %s", file);
#endif
	      fd = fopen (file, "w");
	      /*if (!access(file,W_OK)) */
	      {
		erwin = gtk_editable_get_chars (GTK_EDITABLE (text), 0, -1);
		fprintf (fd, "%s", erwin);
		g_free (erwin);
	      }
	      fclose (fd);
	      set_title_name ();
	      document->changed = FALSE;
	      document->saved = TRUE;
	      document->filename = g_string_new (file);
	      gtk_label_set_text (GTK_LABEL (document->notebook_label), g_basename (file));
	    }
	  else
	    {
	      display_dialog ("Error", "Insufficient permissions\n to write that file");

	    }
	}
      else
	{
	  if (!is_file_readonly (file))
	    {
	      fd = fopen (file, "w");
	      fclose (fd);
	      set_title_name ();
	      document->changed = FALSE;
	      document->filename = g_string_new (file);
	      gtk_label_set_text (GTK_LABEL (document->notebook_label), g_basename (file));
	    }
	}

    }
  else
    {
      save_file_dlg ();
    }
  if (document->close_file && strcmp (file, FILENAME))
    {
      g_print ("\nbla");
      document->close_file = FALSE;
      really_close_file ();
    }
  if (QUIT && strcmp (file, FILENAME))
    {
      really_quit_program ();
    }
}


void
display_main_window (void)
{
  GtkWidget *hbox;
  //GtkWidget *scrollbar;
  GtkWidget *vbox;
  GtkWidget *main_vbox;
  GtkWidget *menubar;
  GtkWidget *toolbar;
  GtkWidget *toolbox;
  gchar erwin[1024] = "";
  FILE *fd;
  struct document *document;
  QUIT = FALSE;
  document = g_malloc (sizeof (struct document));
  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (main_window), NAME " - Untitled");
  gtk_window_position (GTK_WINDOW (main_window), GTK_WIN_POS_CENTER);
  gtk_container_border_width (GTK_CONTAINER (main_window), 5);


  gtk_widget_set_usize (GTK_WIDGET (main_window),
			(gint) (0.7 * gdk_screen_width ()),
			(gint) (0.6 * gdk_screen_height ()));
  gtk_signal_connect (GTK_OBJECT (main_window), "delete_event",
		      GTK_SIGNAL_FUNC (quit_program), NULL);
  gtk_signal_connect (GTK_OBJECT (main_window), "key_press_event",
		      GTK_SIGNAL_FUNC (check_key), NULL);
  gtk_widget_realize (main_window);

  /*---The icon for the windomanager---------------
    style = gtk_widget_get_style(main_window);
    pixmap = gdk_pixmap_create_from_xpm_d(
    main_window->window,
    &mask, &style->bg[GTK_STATE_NORMAL],
    (gchar **)save_xpm);
    gdk_window_set_icon(main_window->window, NULL, pixmap, mask);
    gdk_window_set_icon_name(main_window->window, NAME);
    -------------------DISABLED-----------------------*/
  main_vbox = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (main_window), main_vbox);
  text = gtk_text_new (NULL, NULL);
  document->text = text;
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (main_vbox), vbox, FALSE, FALSE, 0);
/*--- the menubar ---*/
  main_menu (main_window, &menubar);
  gtk_box_pack_start (GTK_BOX (vbox), menubar, FALSE, FALSE, 0);
  gtk_widget_show (menubar);
/*--- the end of menubar ---*/
/*---html-toolbar    ---*/
  toolbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), toolbox, FALSE, FALSE, 5);
  notebook_html = GTK_WIDGET (html_notebook (main_window, toolbox, text));
  gtk_widget_show (notebook_html);
  gtk_widget_show (toolbox);
/*---toolbar-end--*/
  gtk_widget_show (vbox);
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (main_vbox), hbox, TRUE, TRUE, 0);
/*---toolbar    ---*/
  toolbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), toolbox, FALSE, FALSE, 0);
  toolbar = main_toolbar (main_window);
  gtk_box_pack_start (GTK_BOX (toolbox), toolbar, FALSE, FALSE, 0);
  gtk_widget_show (toolbar);
  gtk_widget_show (toolbox);
/*---toolbar-end--*/

  style = gtk_style_copy (gtk_widget_get_style (GTK_WIDGET (text)));
  gtk_style_ref (style);
  font = gdk_font_load ("-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*");
  gdk_font_ref (font);
  style->font = font;
  gtk_widget_set_style (GTK_WIDGET (text), style);
  gtk_text_set_editable (GTK_TEXT (text), TRUE);
  gtk_text_set_word_wrap (GTK_TEXT (text), TRUE);
  //gtk_box_pack_start(GTK_BOX (hbox), text, TRUE, TRUE, 4);
  notebook_main = text_notebook (hbox, document);
  if ((fd = fopen (file, "r")))
    {
      gtk_text_freeze (GTK_TEXT (text));
      while (fgets (erwin, 1024, fd))
	{
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   erwin, strlen (erwin));
	  gtk_editable_set_position (GTK_EDITABLE (text), 0);
	}
      fclose (fd);
      document->saved = TRUE;
      set_title_name ();
      gtk_text_thaw (GTK_TEXT (text));
    }
  gtk_widget_show (notebook_main);
  gtk_widget_show (text);
  //scrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
  //gtk_box_pack_start(GTK_BOX (hbox), scrollbar, FALSE, FALSE, 0);
  //gtk_widget_show (scrollbar);
  gtk_signal_connect (GTK_OBJECT (notebook_main), "switch_page",
		      GTK_SIGNAL_FUNC (switch_page),
		      NULL);

  document->filename = g_string_new (file);
  if (strcmp (file, FILENAME))
    gtk_label_set_text (GTK_LABEL (document->notebook_label), g_basename (file));
  documents = g_list_append (documents, document);
  gtk_widget_show (hbox);
  gtk_widget_show (main_vbox);
  gtk_widget_show (main_window);
  //gtk_window_set_focus(GTK_WINDOW(main_window),text);
}

int
main (int argc, char *argv[])
{
  FILE *fd;
  GString *bla;
  gtk_init (&argc, &argv);
  fprintf (stderr, "%s - html editor, Copyright (C) 1999\nAdrian Reber <adrian@rhlx01.fht-esslingen.de>\nDavid Vogler <david@rhlx01.fht-esslingen.de>\n", NAME);
  fprintf (stderr, "erwin comes with ABSOLUTELY NO WARRANTY - for details read the license.\n");

  if (argc == 2)
    {
      if (!(fd = fopen (argv[1], "r")))
	{
	  /*  g_print("\nSorry, the file %s doesnt probably exist!\nBYE!\n",argv[1]); */
	  if ((fd = fopen (argv[1], "w")))
	    {
	      strcpy (file, argv[1]);
	      fclose (fd);
	    }
	}
      else
	{

	  strcpy (file, argv[1]);
	  fclose (fd);
	}

    }
  if (strcmp (file, FILENAME))
    {
#ifdef DEBUG
      g_print ("\nis path absolute ? %d", g_path_is_absolute (file));
#endif
      if (!g_path_is_absolute (file))
	{
	  bla = g_string_new (g_get_current_dir ());
	  bla = g_string_append (bla, "/");
	  bla = g_string_append (bla, file);
	  strcpy (file, bla->str);
	  g_string_free (bla, TRUE);
	}
#ifdef DEBUG
      g_print ("\ng_basename %s", g_basename (file));
      g_print ("\nis path absolute ? %d", g_path_is_absolute (file));
      g_print ("\ng_get_current_dir %s", g_get_current_dir ());
      g_print ("\ng_dirname %s", g_dirname (file));
      g_print ("\nNow opening %s\n", file);
#endif
    }
  else
    {
#ifdef DEBUG
      g_print ("\nNow opening without file...");
#endif
    }

#ifdef DEBUG
  signal (SIGSEGV, SIG_DFL);
#endif
  display_main_window ();
  gtk_main ();
  return EXIT_SUCCESS;
}
