/* erwin -- html editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *                Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "erwin.h"

extern char file[1024];
static GtkWidget *find_dialog = NULL;
extern gint from_beginning;

void
table_wizard (GtkWidget * widget)
{
  GtkWidget *dialog;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *table;
  GtkWidget *spinner1;
  GtkWidget *spinner2;
  GtkAdjustment *adj;
  table_values.rows = 1;
  table_values.cols = 1;
  IS_TEXT_NULL 
  dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog), NAME);
  gtk_window_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
		      GTK_SIGNAL_FUNC (destroy_message), NULL);
  gtk_signal_connect (GTK_OBJECT (dialog), "destroy",
		      GTK_SIGNAL_FUNC (destroy_message), NULL);

  table = gtk_table_new (2, 4, FALSE);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		      table, TRUE, TRUE, 0);
  label = gtk_label_new ("Rows: ");
  gtk_widget_show (label);

  gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 0, 1);


  adj = (GtkAdjustment *) gtk_adjustment_new (1.0, 1.0, 99.0, 1.0,
					      4.0, 0.0);


  spinner1 = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinner1), TRUE);
  gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spinner1),
				   GTK_SHADOW_ETCHED_IN);

  gtk_signal_connect_object (GTK_OBJECT (spinner1), "changed",
			     GTK_SIGNAL_FUNC (get_value_1), NULL);

  gtk_widget_show (spinner1);

  gtk_table_attach_defaults (GTK_TABLE (table), spinner1, 1, 2, 0, 1);



  label = gtk_label_new ("Columns: ");
  gtk_widget_show (label);

  gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 1, 2);


  adj = (GtkAdjustment *) gtk_adjustment_new (1.0, 1.0, 99.0, 1.0,
					      4.0, 0.0);


  spinner2 = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinner2), TRUE);
  gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spinner2),
				   GTK_SHADOW_ETCHED_IN);
  gtk_widget_show (spinner2);
  gtk_table_attach_defaults (GTK_TABLE (table), spinner2, 1, 2, 1, 2);
  gtk_signal_connect_object (GTK_OBJECT (spinner2), "changed",
			     GTK_SIGNAL_FUNC (get_value_2), NULL);

  gtk_widget_show (table);

  button = gtk_button_new_with_label ("Make it so!");

  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC (destroy_table_wizard),
			     GTK_OBJECT (dialog));

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		      button, TRUE, FALSE, 0);
  gtk_widget_show (button);
  gtk_widget_show (dialog);

}


void
message ()
{
  display_dialog ("Message ...", "Text is to short to save");
}

void
open_file_dlg ()
{
  GtkWidget *filew;
  filew = gtk_file_selection_new ("Open File");
  gtk_signal_connect (GTK_OBJECT (filew), "destroy", (GtkSignalFunc) destroy_message, &filew);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) open_file_ok, filew);
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));
  gtk_widget_show (filew);
}

void
save_file_dlg ()
{
  GtkWidget *filew;
  filew = gtk_file_selection_new ("Save File As");
  gtk_signal_connect (GTK_OBJECT (filew), "destroy", (GtkSignalFunc) destroy_message, &filew);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) save_file_ok, filew);
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));
  if (strcmp (file, FILENAME))
    {
      gtk_file_selection_set_filename (GTK_FILE_SELECTION (filew), file);
    }
  gtk_widget_show (filew);
}

void
close_find_dialog (GtkWidget * widget, gpointer data)
{
  gtk_widget_destroy (GTK_WIDGET (data));
  from_beginning = 0;
  find_dialog = NULL;
}

void
find_dlg ()
{
  GtkWidget *button, *button1;
  GtkWidget *hbox, *main_box, *frame_box, *button_box;
  GtkWidget *frame;
  static struct frame_entry frame_entry;
  IS_TEXT_NULL
  if (find_dialog)
    {
#ifdef DEBUG
      g_print ("\nDialog already open...\n");
#endif
      gdk_window_raise (find_dialog->window);
      return;
    }

  find_dialog = gtk_dialog_new ();

  gtk_signal_connect (GTK_OBJECT (find_dialog), "destroy",
		      GTK_SIGNAL_FUNC (close_find_dialog),
		      find_dialog);
  gtk_window_set_title (GTK_WINDOW (find_dialog), "Find");
  gtk_window_position (GTK_WINDOW (find_dialog), GTK_WIN_POS_CENTER);
  gtk_container_border_width (GTK_CONTAINER (find_dialog), 5);
  main_box = gtk_vbox_new (TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (find_dialog)->vbox),
		      main_box, TRUE, TRUE, 1);
  hbox = gtk_hbox_new (TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (main_box),
		      hbox, TRUE, TRUE, 2);
  entry_in_frame ("Find What?", &frame_entry);
  gtk_box_pack_start (GTK_BOX (hbox),
		      frame_entry.frame, TRUE, TRUE, 0);
  if (to_be_searched)
    {
      gtk_entry_set_text (GTK_ENTRY (frame_entry.entry), to_be_searched);
    }
  GTK_WIDGET_SET_FLAGS (GTK_WIDGET (frame_entry.entry), GTK_CAN_DEFAULT);
  gtk_widget_show (hbox);
  frame_box = gtk_vbox_new (FALSE, FALSE);
  gtk_box_pack_start (GTK_BOX (main_box),
		      frame_box, FALSE, FALSE, 2);
  frame = gtk_frame_new ("Options");
  gtk_box_pack_start (GTK_BOX (frame_box),
		      frame, FALSE, FALSE, 0);
  gtk_frame_set_label_align (GTK_FRAME (frame), 0, 0);
  button_box = gtk_vbox_new (FALSE, FALSE);
  gtk_container_add (GTK_CONTAINER (frame), button_box);
  find_options.case_sensitive = gtk_check_button_new_with_label ("Case Sensitive");
  gtk_box_pack_start (GTK_BOX (button_box),
		 GTK_WIDGET (find_options.case_sensitive), FALSE, FALSE, 0);
  /* If entry is changed, search from start should be enabled again */
  gtk_widget_show (GTK_WIDGET (find_options.case_sensitive));

  find_options.from_beginning = gtk_check_button_new_with_label ("Start at beginning");
  gtk_box_pack_start (GTK_BOX (button_box),
		 GTK_WIDGET (find_options.from_beginning), FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (find_options.from_beginning), "clicked",
		      GTK_SIGNAL_FUNC (find_entry_changed), NULL);

  gtk_widget_show (GTK_WIDGET (find_options.from_beginning));
  gtk_widget_show (frame);
  gtk_widget_show (button_box);
  gtk_widget_show (frame_box);

  gtk_widget_show (main_box);
  button1 = gtk_button_new_with_label ("Find Next");
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
		      GTK_SIGNAL_FUNC (find_function),
		      frame_entry.entry);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (find_dialog)->action_area),
		      button1, FALSE, FALSE, 0);

  gtk_widget_show (button1);
  button = gtk_button_new_with_label ("Cancel");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (close_find_dialog),
		      find_dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (find_dialog)->action_area),
		      button, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (frame_entry.entry), "key_press_event",
		      GTK_SIGNAL_FUNC (find_entry_changed), NULL);

  gtk_widget_show (button);
  gtk_widget_grab_default (button1);

  gtk_widget_show (find_dialog);

}

void
close_body_dialog (GtkWidget * widget, gpointer data)
{
  gtk_grab_remove (GTK_WIDGET (data));
  gtk_widget_destroy (GTK_WIDGET (data));
}

void
body_dialog ()
{
  GtkWidget *button;
  GtkWidget *hbox;
  GtkWidget *hbox_1;
  IS_TEXT_NULL
  body_elements.dialog = gtk_dialog_new ();
  gtk_signal_connect (GTK_OBJECT (body_elements.dialog), "destroy",
		      GTK_SIGNAL_FUNC (close_body_dialog),
		      body_elements.dialog);
  gtk_window_set_title (GTK_WINDOW (body_elements.dialog), "Body");
  gtk_window_position (GTK_WINDOW (body_elements.dialog), GTK_WIN_POS_CENTER);
  gtk_container_border_width (GTK_CONTAINER (body_elements.dialog), 5);
  hbox = gtk_vbox_new (TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (body_elements.dialog)->vbox),
		      hbox, TRUE, TRUE, 0);
  /* TITLE */
  entry_in_frame ("Title", &body_elements.title);
  gtk_box_pack_start (GTK_BOX (hbox),
		      body_elements.title.frame, TRUE, TRUE, 0);
  /* BGCOLOR */
  entry_in_frame ("Background Color", &body_elements.bgcolor);
  gtk_box_pack_start (GTK_BOX (hbox),
		      body_elements.bgcolor.frame, TRUE, TRUE, 0);
  /* TEXT */
  entry_in_frame ("Text Color", &body_elements.text);
  gtk_box_pack_start (GTK_BOX (hbox),
		      body_elements.text.frame, TRUE, TRUE, 0);
  /* LINK */
  entry_in_frame ("Link Color", &body_elements.link);
  gtk_box_pack_start (GTK_BOX (hbox),
		      body_elements.link.frame, TRUE, TRUE, 0);
  /* VLINK */
  entry_in_frame ("Visited Link Color", &body_elements.vlink);
  gtk_box_pack_start (GTK_BOX (hbox),
		      body_elements.vlink.frame, TRUE, TRUE, 0);
  /* ALINK */
  entry_in_frame ("Active Link Color", &body_elements.alink);
  gtk_box_pack_start (GTK_BOX (hbox),
		      body_elements.alink.frame, TRUE, TRUE, 0);
/*BACKGROUD IMAGE */


  hbox_1 = entry_in_frame ("Background Image", &body_elements.background);
  gtk_box_pack_start (GTK_BOX (hbox),
		      body_elements.background.frame, TRUE, TRUE, 5);
  button = gtk_button_new_with_label ("Browse Image");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (body_img_function),
		      NULL);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);

  gtk_box_pack_start (GTK_BOX (hbox_1),
		      button, FALSE, FALSE, 50);
  gtk_widget_show (button);

/* GENERATOR TAG */
  body_elements.insert_generator = gtk_check_button_new_with_label ("Insert <meta name=\"GENERATOR\" content=\"" NAME "\">");
  gtk_box_pack_start (GTK_BOX (hbox),
	      GTK_WIDGET (body_elements.insert_generator), FALSE, FALSE, 0);
  gtk_widget_show (body_elements.insert_generator);
/*DOCUMENT TYPE TAG */
  body_elements.content_type = gtk_check_button_new_with_label ("Insert <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">");
  gtk_box_pack_start (GTK_BOX (hbox),
		  GTK_WIDGET (body_elements.content_type), FALSE, FALSE, 0);
  gtk_widget_show (body_elements.content_type);


  button = gtk_button_new_with_label ("Make it so!");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (ok_body_dialog),
		      body_elements.dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (body_elements.dialog)->action_area),
		      button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);

  button = gtk_button_new_with_label ("Cancel");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (close_body_dialog),
		      body_elements.dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (body_elements.dialog)->action_area),
		      button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);

  gtk_widget_show (hbox);
  gtk_widget_show (body_elements.dialog);
  gtk_grab_add (body_elements.dialog);

}

void
href_dialog ()
{
  struct change change;
  struct change help;
  GList *list;
  GtkWidget *dialog;
  GtkWidget *hbox;
  GtkWidget *vbox;
  GtkWidget *button;
  IS_TEXT_NULL
  list = NULL;
  list = g_list_append (list, "none");
  list = g_list_append (list, "http://");
  list = g_list_append (list, "ftp://");
  list = g_list_append (list, "mailto:");

  dialog = gtk_dialog_new ();
  gtk_signal_connect_object (GTK_OBJECT (dialog), "destroy", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (dialog));
  gtk_window_set_title (GTK_WINDOW (dialog), "Insert Hyperlink");
  vbox = gtk_vbox_new (TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), vbox,
		      TRUE, TRUE, 0);
  hbox = gtk_hbox_new (TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), hbox,
		      TRUE, TRUE, 0);
  combo_in_frame ("Protocol", &hyperlink.protocol, list);
  gtk_box_pack_start (GTK_BOX (hbox), hyperlink.protocol.frame, TRUE, TRUE, 0);
  entry_in_frame ("Link Destination", &hyperlink.link);
  gtk_box_pack_start (GTK_BOX (hbox), hyperlink.link.frame, TRUE, TRUE, 0);
  entry_in_frame ("Link Name", &hyperlink.name);
  gtk_box_pack_start (GTK_BOX (vbox), hyperlink.name.frame, TRUE, TRUE, 0);
  if (GTK_EDITABLE (text)->has_selection)
    {
      change = test_selection (text);	/* Getting start and end position */
      help = change;
      gtk_entry_set_text (GTK_ENTRY (hyperlink.name.entry),
			  gtk_editable_get_chars (GTK_EDITABLE (text), change.start, change.end));
      GTK_EDITABLE (text)->selection_start_pos = help.start;
      GTK_EDITABLE (text)->selection_end_pos = help.end;
      GTK_EDITABLE (text)->has_selection = 1;
    }

  button = gtk_button_new_with_label ("Make it so!");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (href_function_ok),
		      dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		      button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);

  button = gtk_button_new_with_label ("Cancel");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (close_body_dialog),
		      dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		      button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);

  gtk_widget_show (hbox);
  gtk_widget_show (vbox);
  gtk_grab_add (dialog);
  gtk_widget_show (dialog);


}

void
font_dialog ()
{
  GtkWidget *hbox;
  GtkWidget *vbox;
  GtkAdjustment *adj;
  GtkWidget *button;
  GtkWidget *frame;
  IS_TEXT_NULL
  font_options.dialog = gtk_dialog_new ();
  gtk_signal_connect (GTK_OBJECT (font_options.dialog), "destroy",
		      GTK_SIGNAL_FUNC (close_body_dialog),
		      font_options.dialog);
  gtk_window_set_title (GTK_WINDOW (font_options.dialog), "Font Options");
  gtk_window_position (GTK_WINDOW (font_options.dialog), GTK_WIN_POS_CENTER);
  gtk_container_border_width (GTK_CONTAINER (font_options.dialog), 5);
  hbox = gtk_vbox_new (TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (font_options.dialog)->vbox),
		      hbox, TRUE, TRUE, 0);

  /* FONT FACE */
  entry_in_frame ("Font Face", &font_options.face);
  gtk_box_pack_start (GTK_BOX (hbox),
		      font_options.face.frame, TRUE, TRUE, 0);
  /* FONT COLOR */
  entry_in_frame ("Font Color", &font_options.color);
  gtk_box_pack_start (GTK_BOX (hbox),
		      font_options.color.frame, TRUE, TRUE, 0);
  /* FONT SIZE */
  frame = gtk_frame_new ("Font Size");

  gtk_box_pack_start (GTK_BOX (hbox),
		      frame, TRUE, TRUE, 0);
  vbox = gtk_hbox_new (TRUE, TRUE);
  gtk_container_add (GTK_CONTAINER (frame), vbox);



  adj = (GtkAdjustment *) gtk_adjustment_new (0.0, 0.0, 7.0, 1.0,
					      0.0, 0.0);
  font_options.size = gtk_spin_button_new (adj, 0, 0);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (font_options.size), TRUE);
  gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (font_options.size),
				   GTK_SHADOW_ETCHED_IN);


  gtk_box_pack_start (GTK_BOX (vbox),
		      font_options.size, TRUE, TRUE, 0);

  gtk_widget_show (vbox);
  gtk_widget_show (frame);


  gtk_widget_show (font_options.size);
  gtk_widget_show (hbox);
  button = gtk_button_new_with_label ("Make it so!");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (font_function_ok),
		      font_options.dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (font_options.dialog)->action_area),
		      button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);

  button = gtk_button_new_with_label ("Cancel");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (close_body_dialog),
		      font_options.dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (font_options.dialog)->action_area),
		      button, FALSE, FALSE, 0);
  gtk_widget_show (button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_show (font_options.dialog);
  gtk_grab_add (font_options.dialog);
}

void
help_about_menu (GtkWidget * widget)
{
  display_dialog ("About ...", NAME " - html editor, Copyright (C) 1999\n Adrian Reber <adrian@rhlx01.fht-esslingen.de>\nDavid Vogler <david@rhlx01.fht-esslingen.de>\nhttp://www-stud.fht-esslingen.de/erwin/\nerwin comes with ABSOLUTELY NO WARRANTY - for details read the license.");
}
