/* erwin -- html editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *                Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef ERWIN_FUNCTIONS_H
#define ERWIN_FUNCTIONS_H
#include "erwindef.h"
/* All erwinfunctions.c prototypes */

void copy_to_clipboard (GtkWidget *);
void cut_to_clipboard (GtkWidget *);
void paste_from_clipboard (GtkWidget *);
void insert_text (char *, gint);
void img_functions (GtkWidget *);
void body_img_function (GtkWidget *);
void file_ok_sel (GtkWidget *, GtkFileSelection *);
gint move_cursor (gint, ErwinCursor);
struct change test_selection (gpointer);
void insert_text_around (gpointer, struct change, char *, gint);
GdkColor *get_main_tooltips_bgcolor (GdkWindow *, GdkColormap *);
void destroy_message (GtkWidget *);
gint delete_event (GtkWidget *, GdkEvent *, gpointer);
void quit_program ();
void really_quit_program ();
void get_value_1 (GtkWidget *, GtkWidget *);
void get_value_2 (GtkWidget *, GtkWidget *);
void destroy_table_wizard (GtkWidget *);
void check_key (GtkWidget *, GdkEventKey *);
void find_entry_changed (GtkWidget *);
void open_file_ok (GtkWidget *, GtkFileSelection *);
void save_file_ok (GtkWidget *, GtkFileSelection *);
void new_file ();
void close_message_dialog (GtkWidget *, gpointer);
void ungrab_message (GtkWidget *, gpointer);
void display_dialog (gchar *, gchar *);
void find_function (GtkWidget *, gpointer);
gint look_for_string (gchar *, gint);
GtkWidget *entry_in_frame (gchar *, struct frame_entry *);
void body_functions ();
void legal ();
void set_title_name ();
void ok_body_dialog (GtkWidget *, gpointer);
void make_body_options_string (GString *, gchar *, struct frame_entry *);
gboolean does_file_exist (gchar *);
gboolean is_file_readonly (gchar *);
gboolean is_file_a_directory (gchar *);
void insert_symmetric_tag (gchar *);
void body_img_file_ok_sel (GtkWidget *, GtkWidget *);
void href_function_ok (GtkWidget *, gpointer);
GtkWidget *combo_in_frame (gchar *, struct frame_combo *, GList *);
void font_function_ok (GtkWidget *, gpointer);
gushort convert_color (guint);
void extract_color (GdkColor *, guint, guint, guint);
void apply_syntax_highlighting ();
void undo_syntax_highlighting ();
void switch_page (GtkWidget * widget, GtkNotebookPage *, gint);
void close_file ();
void switch_html_page ();
void really_close_file ();
void close_ask_no (GtkWidget *, gpointer);
void close_ask_yes (GtkWidget *, gpointer);
void quit_ask_no (GtkWidget *, gpointer);
void quit_ask_yes (GtkWidget *, gpointer);
#endif /* ERWIN_FUNCTIONS_H */
