/* erwin -- html editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *		  Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "erwin.h"

GtkWidget* main_menu(GtkWidget *window, GtkWidget **menubar)
{
  GtkItemFactory *factory;
  GtkAccelGroup *accel_group;
  static GtkItemFactoryEntry menu_items[] = {
        {"/_File",      NULL,   0,              0,      "<Branch>"},
	{"/File/_New",	"<control>N",   new_file,0},
	{"/File/_Open",	"<control>O",	open_file_dlg,	0},
	{"/File/_Save", "<control>S",   save_file,      0},
        {"/File/Save _As",NULL,	save_file_dlg,0},
	{"/File/_Close", NULL,   close_file,      0},
        {"/File/_Quit", "<control>Q",   quit_program,0},
        {"/_Edit",      NULL,   0,              0,      "<Branch>"},
        {"/Edit/Cut",   "<control>X",   cut_to_clipboard,       0},
        {"/Edit/Copy",  "<control>C",   copy_to_clipboard,      0},
        {"/Edit/Paste", "<control>V",   paste_from_clipboard,   0},
	{"/Edit/sep",   NULL,   0,      0,      "<Separator>"},
	{"/Edit/Find", "F3", find_dlg,0}, 
	{"/H_tml",	NULL, 0, 0, "<Branch>"},
	{"/Html/Fonts", NULL,0,0,"<Branch>"},
	{"/Html/Fonts/Underline <u>", NULL, underline_functions,0},
        {"/Html/Fonts/Italic <i>", NULL, italic_functions,0},
        {"/Html/Fonts/Bold <b>", NULL, bold_functions,0},
	{"/Html/Fonts/H1 <h1>", NULL, h1_functions,0},
        {"/Html/Fonts/H1 <h2>", NULL, h2_functions,0},
        {"/Html/Fonts/H1 <h3>", NULL, h3_functions,0},
        {"/Html/Fonts/Center <center>", NULL, center_functions,0},
	{"/Html/Fonts/Font Options <font>", NULL, font_dialog,0},
	{"/Html/Table and Lists", NULL,0,0,"<Branch>"},
	{"/Html/Table and Lists/Table <table>", NULL,table_functions,0},
	{"/Html/Table and Lists/Table Header <th>", NULL,th_functions,0},
	{"/Html/Table and Lists/Table Row <tr>", NULL,tr_functions,0},
	{"/Html/Table and Lists/Table Data <td>", NULL,td_functions,0},
        {"/Html/Table and Lists/Ordered List <ol>", NULL,ol_functions,0},
        {"/Html/Table and Lists/Unordered List <ul>", NULL,ul_functions,0},
        {"/Html/Table and Lists/List Item <li>", NULL,li_functions,0},
	{"/Html/HTML/Insert Link","<control>L" ,href_dialog,0},
	{"/Html/HTML/Insert Image Link","<control>I",img_functions,0},
	{"/Html/HTML/Quick Start",NULL,body_functions,0},
	{"/Html/HTML/Linebreak <br>","<control>R",br_functions,0},
	{"/Html/HTML/Paragraph <p>",NULL,p_functions,0},
	{"/Html/HTML/Space &nbsp;",NULL,nbsp_functions,0},
	{"/Html/HTML/Emphasis <em>",NULL,em_functions,0},
	{"/Html/HTML/Strong <strong>",NULL,strong_functions,0},
	{"/Html/HTML/Small <small>",NULL,small_functions,0},
	{"/Html/HTML/Strikeout <strike>",NULL,nbsp_functions,0},
	{"/Html/HTML/Subscript <sub>",NULL,sub_functions,0},
	{"/Html/HTML/Superscript <sup>",NULL,sup_functions,0},
	{"/Html/Table Wizard","<control>T" ,table_wizard,0},
	{"/Html/Quickstart",NULL,body_dialog,0},
	{"/_Options/Apply Syntax Highlighting",NULL,apply_syntax_highlighting,0},
	{"/_Options/Undo Syntax Highlighting",NULL,undo_syntax_highlighting,0},
	{"/_Help",      NULL,   0,      0,      "<LastBranch>"},
        {"/Help/_Legal & License",        NULL,   legal,       0 },
        {"/Help/sep",   NULL,   0,      0,      "<Separator>"},
        {"/Help/_About",        NULL,   help_about_menu,        0}
};
  gint nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);
  accel_group = gtk_accel_group_new();
  factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);
  gtk_item_factory_create_items (factory, nmenu_items, menu_items, NULL);
  gtk_accel_group_attach (accel_group, GTK_OBJECT (window));
  if (menubar)
          *menubar = gtk_item_factory_get_widget (factory, "<main>");
  return *menubar;
}
