/* erwin -- html editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *                Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


#include "erwin.h"

GtkWidget *
html_notebook (GtkWidget * main_window, GtkWidget * box, GtkWidget * text)
{
  GtkWidget *notebook;
  GtkWidget *label;
  GtkWidget *toolbar;

  notebook = gtk_notebook_new ();
  gtk_box_pack_start (GTK_BOX (box), notebook, FALSE, FALSE, 0);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
  label = gtk_label_new ("HTML");
  gtk_widget_show (label);
  toolbar = html_toolbar (main_window, text);
  gtk_widget_show (toolbar);
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), toolbar, label);
  label = gtk_label_new ("Fonts");
  gtk_widget_show (label);
  toolbar = font_toolbar (main_window, text);
  gtk_widget_show (toolbar);
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), toolbar, label);
  label = gtk_label_new ("Tables/Lists");
  gtk_widget_show (label);
  toolbar = table_toolbar (main_window, text);
  gtk_widget_show (toolbar);
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), toolbar, label);
  gtk_signal_connect (GTK_OBJECT (notebook), "switch_page",
                      GTK_SIGNAL_FUNC (switch_html_page),
                      NULL);
  return notebook;
}

GtkWidget *
text_notebook (GtkWidget * target_box, struct document * document)
{
  GtkWidget *notebook;
  GtkWidget *label;
  GtkWidget *scrollbar;
  GtkWidget *text_box;

  notebook = gtk_notebook_new ();
  gtk_box_pack_start (GTK_BOX (target_box), notebook, TRUE, TRUE, 4);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_BOTTOM);
  label = gtk_label_new ("Untitled");
  gtk_widget_show (label);
  text_box = gtk_hbox_new (FALSE, FALSE);
  gtk_box_pack_start (GTK_BOX (text_box), text, TRUE, TRUE, 0);
  scrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
  gtk_box_pack_start (GTK_BOX (text_box), scrollbar, FALSE, FALSE, 0);
  gtk_widget_show (scrollbar);
  gtk_widget_show (text_box);
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), text_box, label);
  document->nr_of_notebook_child = nr_of_documents = 0;
  document->notebook = notebook;
  document->notebook_child = text_box;
  document->notebook_label = label;
  document->changed = FALSE;
  document->saved   = FALSE;
  document->close_file = FALSE;
  return notebook;
}
