/* GTKMESSAGE

 * Adrian Reber <adrian@rhlx01.fht-esslingen.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GTK_MESSAGE_H__
#define __GTK_MESSAGE_H__


#include <gdk/gdk.h>
#include <gtk/gtkwindow.h>


#ifdef __cplusplus
extern "C"
{
#endif				/* __cplusplus */


#define GTK_TYPE_MESSAGE                  (gtk_message_get_type ())
#define GTK_MESSAGE(obj)                  (GTK_CHECK_CAST ((obj), GTK_TYPE_MESSAGE, GtkMessage))
#define GTK_MESSAGE_CLASS(klass)          (GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_MESSAGE, GtkMessageClass))
#define GTK_IS_MESSAGE(obj)               (GTK_CHECK_TYPE ((obj), GTK_TYPE_MESSAGE))
#define GTK_IS_MESSAGE_CLASS(klass)       (GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_MESSAGE))


  typedef struct _GtkMessage GtkMessage;
  typedef struct _GtkMessageClass GtkMessageClass;
  typedef struct _GtkMessageButton GtkMessageButton;


  struct _GtkMessage
    {
      GtkWindow window;

      GtkWidget *vbox;
      GtkWidget *action_area;
      GtkWidget *button;
      GtkWidget *label;
      gint nr_of_buttons;
    };

  struct _GtkMessageClass
    {
      GtkWindowClass parent_class;
    };


  GtkType gtk_message_get_type (void);
  GtkWidget *gtk_message_new (void);
  void gtk_message_set_label (GtkMessage * message, const gchar * label);
  void
    gtk_message_set_nr_of_buttons (GtkMessage * message, gint size);
  GtkWidget *
    gtk_message_add_button (GtkMessage * message, gint index, gchar * button_label);
#ifdef __cplusplus
}
#endif				/* __cplusplus */


#endif				/* __GTK_MESSAGE_H__ */
